Raritan PX2/PX3 JSON-RPC API

DisplayControl.idl
1 /* SPDX-License-Identifier: BSD-3-Clause */
2 /*
3 * Copyright 2014 Raritan Inc. All rights reserved.
4 */
5
6 #include <UserEvent.idl>
7
8 /** Front panel display interface */
9 module display {
10 /**
11 * Interface to control the device's front panel display
12 */
13 interface DisplayControl_1_0_1 {
14 /**
15 * Error codes
16 */
17 constant int SUCCESS = 0; ///< No error
18 constant int ERR_INVALID_VALUE = 1; ///< Invalid argument
19
20 /** Collected display meta information */
21 structure Info {
22 int fwAppVersion; ///< Firmware application version; 0 if unavailable
23 int fwBootVersion; ///< Firmware bootloader version; 0 if unavailable
24 int orientation; ///< Display orientation
25 int width; ///< Display width
26 int height; ///< Display height
27 boolean versionAvailable; ///< \c true if version information is available
28 };
29
30 /**
31 * Representation of a possible default view
32 */
33 structure DefaultViewItem {
34 string id; ///< View ID
35 string description; ///< Textual description
36 };
37
38 /** Event: The default view was changed */
39 valueobject DefaultViewChangedEvent extends event.UserEvent {
40 DefaultViewItem newView; ///< New default view
41 };
42
43 /**
44 * Get available default views. This returns all views that can be
45 * used as default views on the device display.
46 *
47 * @return Possible default views, or empty list if the default view
48 * can not be configured for the device's display
49 */
50 vector<DefaultViewItem> getAvailableDefaultViews();
51
52 /**
53 * Get the currently active default view.
54 *
55 * @return View ID of current default view.
56 * If the device doesn't allow configuration of
57 * the default view, an empty string is returned.
58 */
59 string getDefaultView();
60
61 /**
62 * Set the active default view.
63 *
64 * @param id View ID of new default view
65 *
66 * @return 0 on success
67 * @return 1 if id is not part of the key set returned by
68 * getAvailableDefaultViews
69 */
70 int setDefaultView(in string id);
71
72 /**
73 * Retrieve display's meta information.
74 *
75 * @return Display information
76 */
77 Info getInfo();
78
79 /**
80 * Show smiley on display
81 *
82 * @param on \c true to turn on smiley
83 * @param happy \c true to show happy smiley,\c false to show sad smiley
84 * @param msg String for message
85 */
86 void showSmiley(in boolean on, in boolean happy, in string msg);
87 };
88 }
display
Front panel display interface.
Definition: DisplayControl.idl:9
display::DisplayControl_1_0_1::Info::versionAvailable
boolean versionAvailable
true if version information is available
Definition: DisplayControl.idl:27
display::DisplayControl_1_0_1::Info::fwAppVersion
int fwAppVersion
Firmware application version; 0 if unavailable.
Definition: DisplayControl.idl:22
display::DisplayControl_1_0_1::DefaultViewItem::id
string id
View ID.
Definition: DisplayControl.idl:34
display::DisplayControl_1_0_1::Info::width
int width
Display width.
Definition: DisplayControl.idl:25
display::DisplayControl_1_0_1::Info
Collected display meta information.
Definition: DisplayControl.idl:21
display::DisplayControl_1_0_1
Interface to control the device&#39;s front panel display.
Definition: DisplayControl.idl:13
display::DisplayControl_1_0_1::DefaultViewItem
Representation of a possible default view.
Definition: DisplayControl.idl:33
display::DisplayControl_1_0_1::DefaultViewItem::description
string description
Textual description.
Definition: DisplayControl.idl:35
display::DisplayControl_1_0_1::Info::height
int height
Display height.
Definition: DisplayControl.idl:26
display::DisplayControl_1_0_1::Info::fwBootVersion
int fwBootVersion
Firmware bootloader version; 0 if unavailable.
Definition: DisplayControl.idl:23
display::DisplayControl_1_0_1::Info::orientation
int orientation
Display orientation.
Definition: DisplayControl.idl:24